Init is now even more perfect then before.
 -Erik
diff --git a/Makefile b/Makefile
index 73aa2fc..6f49f0a 100644
--- a/Makefile
+++ b/Makefile
@@ -80,12 +80,8 @@
 OBJECTS=$(shell ./busybox.sh)
 CFLAGS+= -DBB_VER='"$(VERSION)"'
 CFLAGS+= -DBB_BT='"$(BUILDTIME)"'
-ifdef BB_INIT_RC_EXIT_CMD
-    CFLAGS += -DBB_INIT_CMD_IF_RC_SCRIPT_EXITS=${BB_INIT_RC_EXIT_CMD}
-endif
-
 ifdef BB_INIT_SCRIPT
-    CFLAGS += -DBB_INIT_SCRIPT=${BB_INIT_SCRIPT}
+    CFLAGS += -DINIT_SCRIPT=${BB_INIT_SCRIPT}
 endif
 
 all: busybox busybox.links
diff --git a/busybox.def.h b/busybox.def.h
index 0321465..8345553 100644
--- a/busybox.def.h
+++ b/busybox.def.h
@@ -88,6 +88,12 @@
 //
 //
 //
+// Don't turn BB_UTILITY off.  It contains support code 
+// that compiles to 0 if everything else if turned off.
+#define BB_UTILITY
+//
+//
+//
 // This is where feature definitions go.  Generally speaking,
 // turning this stuff off makes things a bit smaller (and less 
 // pretty/useful).
@@ -113,10 +119,3 @@
 //Enable init being called as /linuxrc
 #define BB_FEATURE_LINUXRC
 //
-//
-//
-// Don't turn BB_UTILITY off.  It contains support code 
-// that compiles to 0 if everything else if turned off.
-#define BB_UTILITY
-//
-//
diff --git a/busybox.spec b/busybox.spec
index a852007..d1a7026 100644
--- a/busybox.spec
+++ b/busybox.spec
@@ -21,7 +21,7 @@
 %setup -q -n %{Name}-%{Version}
 
 %Build
-BB_INIT_RC_EXIT_CMD=\"/bin/sh\" BB_INIT_SCRIPT=\"/etc/rc.d/init.d/rcS\" make
+BB_INIT_SCRIPT='\"/etc/rc.d/init.d/rcS\"' make
 
 %Install
 rm -rf $RPM_BUILD_ROOT
diff --git a/examples/busybox.spec b/examples/busybox.spec
index a852007..d1a7026 100644
--- a/examples/busybox.spec
+++ b/examples/busybox.spec
@@ -21,7 +21,7 @@
 %setup -q -n %{Name}-%{Version}
 
 %Build
-BB_INIT_RC_EXIT_CMD=\"/bin/sh\" BB_INIT_SCRIPT=\"/etc/rc.d/init.d/rcS\" make
+BB_INIT_SCRIPT='\"/etc/rc.d/init.d/rcS\"' make
 
 %Install
 rm -rf $RPM_BUILD_ROOT
diff --git a/init.c b/init.c
index 0472208..88b8ed1 100644
--- a/init.c
+++ b/init.c
@@ -61,9 +61,11 @@
 #define VT_LOG          "/dev/tty3"	  /* Virtual console */
 #define SERIAL_CON0     "/dev/ttyS0"      /* Primary serial console */
 #define SERIAL_CON1     "/dev/ttyS1"      /* Serial console */
-#define SHELL           "-sh"		  /* Default shell */
+#define SHELL           "/bin/sh"	  /* Default shell */
 #define INITTAB         "/etc/inittab"	  /* inittab file location */
+#ifndef INIT_SCRIPT
 #define INIT_SCRIPT	"/etc/init.d/rcS" /* Default sysinit script. */
+#endif
 
 #define LOG             0x1
 #define CONSOLE         0x2
@@ -330,6 +332,7 @@
 	"\nPlease press Enter to activate this console. ";
 
     if ((pid = fork()) == 0) {
+	int fd;
 	pid_t shell_pgid = getpid ();
 
 	/* Clean up */
@@ -338,17 +341,14 @@
 	close(2);
 	setsid();
 
-	if (device_open(terminal, O_RDWR) < 0) {
+	if ((fd=device_open(terminal, O_RDWR)) < 0) {
 	    message(LOG|CONSOLE, "Bummer, can't open %s\r\n", terminal);
 	    exit(1);
 	}
-	dup(0);
-	dup(0);
-	/* Grab control of the terminal.  */
-	if (tcsetpgrp (0, getpgrp()) < 0) {
-	    message(LOG|CONSOLE, "tcsetpgrp error: %s\r\n", strerror(errno));
-	}
-	set_term(0);
+	dup(fd);
+	dup(fd);
+	set_term(fd);
+	tcsetpgrp (fd, getpgrp());
 
 	/* Reset signal handlers set for parent process */
 	signal(SIGUSR1, SIG_DFL);
@@ -497,7 +497,7 @@
 
 #endif
 
-void new_initAction (const struct initActionType *a, 
+void new_initAction (initActionEnum action,
 	char* process, char* cons)
 {
     initAction* newAction;
@@ -517,7 +517,7 @@
     newAction->nextPtr = initActionList;
     initActionList = newAction;
     strncpy( newAction->process, process, 255);
-    newAction->action = a->action;
+    newAction->action = action;
     if (*cons != '\0') {
 	strncpy(newAction->console, cons, 255);
     } else
@@ -561,12 +561,12 @@
 	/* No inittab file -- set up some default behavior */
 #endif
 	/* Askfirst shell on tty1 */
-	new_initAction( &(actions[3]), SHELL, console );
+	new_initAction( ASKFIRST, SHELL, console );
 	/* Askfirst shell on tty2 */
 	if (second_console != NULL) 
-	    new_initAction( &(actions[3]), SHELL, second_console );
+	    new_initAction( ASKFIRST, SHELL, second_console );
 	/* sysinit */
-	new_initAction( &(actions[0]), INIT_SCRIPT, console );
+	new_initAction( SYSINIT, INIT_SCRIPT, console );
 
 	return;
 #ifdef BB_FEATURE_USE_INITTAB
@@ -584,7 +584,6 @@
 
 	/* Keep a copy around for posterity's sake (and error msgs) */
 	strcpy(lineAsRead, buf);
-message(LOG|CONSOLE, "read='%s'\n", lineAsRead);
 
 	/* Grab the ID field */
 	s=p;
@@ -628,7 +627,7 @@
 		    }
 		    s = tmpConsole;
 		}
-		new_initAction( a, q, s);
+		new_initAction( a->action, q, s);
 		foundIt=TRUE;
 	    }
 	    a++;
@@ -712,9 +711,9 @@
     {
 	/* Ask first then start a shell on tty2 */
 	if (second_console != NULL) 
-	    new_initAction( &(actions[3]), SHELL, second_console);
+	    new_initAction( ASKFIRST, SHELL, second_console);
 	/* Ask first then start a shell on tty1 */
-	new_initAction( &(actions[3]), SHELL, console);
+	new_initAction( ASKFIRST, SHELL, console);
     } else {
 	/* Not in single user mode -- see what inittab says */
 
@@ -731,7 +730,7 @@
     /* First run the sysinit command */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == SYSINIT) {
-	    waitfor(a->process, console, FALSE);
+	    waitfor(a->process, a->console, FALSE);
 	    /* Now remove the "sysinit" entry from the list */
 	    delete_initAction( a);
 	}
@@ -739,7 +738,7 @@
     /* Next run anything that wants to block */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == WAIT) {
-	    waitfor(a->process, console, FALSE);
+	    waitfor(a->process, a->console, FALSE);
 	    /* Now remove the "wait" entry from the list */
 	    delete_initAction( a);
 	}
@@ -747,7 +746,7 @@
     /* Next run anything to be run only once */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == ONCE) {
-	    run(a->process, console, FALSE);
+	    run(a->process, a->console, FALSE);
 	    /* Now remove the "once" entry from the list */
 	    delete_initAction( a);
 	}
@@ -760,7 +759,6 @@
 
     /* Now run the looping stuff for the rest of forever */
     while (1) {
-	message(LOG|CONSOLE, "Looping\n");
 	for( a=initActionList ; a; a=a->nextPtr) {
 	    /* Only run stuff with pid==0.  If they have
 	     * a pid, that means they are still running */
@@ -768,11 +766,11 @@
 		switch(a->action) {
 		    case RESPAWN:
 			/* run the respawn stuff */
-			a->pid = run(a->process, console, FALSE);
+			a->pid = run(a->process, a->console, FALSE);
 			break;
 		    case ASKFIRST:
 			/* run the askfirst stuff */
-			a->pid = run(a->process, console, TRUE);
+			a->pid = run(a->process, a->console, TRUE);
 			break;
 		    /* silence the compiler's incessant whining */
 		    default:
diff --git a/init/init.c b/init/init.c
index 0472208..88b8ed1 100644
--- a/init/init.c
+++ b/init/init.c
@@ -61,9 +61,11 @@
 #define VT_LOG          "/dev/tty3"	  /* Virtual console */
 #define SERIAL_CON0     "/dev/ttyS0"      /* Primary serial console */
 #define SERIAL_CON1     "/dev/ttyS1"      /* Serial console */
-#define SHELL           "-sh"		  /* Default shell */
+#define SHELL           "/bin/sh"	  /* Default shell */
 #define INITTAB         "/etc/inittab"	  /* inittab file location */
+#ifndef INIT_SCRIPT
 #define INIT_SCRIPT	"/etc/init.d/rcS" /* Default sysinit script. */
+#endif
 
 #define LOG             0x1
 #define CONSOLE         0x2
@@ -330,6 +332,7 @@
 	"\nPlease press Enter to activate this console. ";
 
     if ((pid = fork()) == 0) {
+	int fd;
 	pid_t shell_pgid = getpid ();
 
 	/* Clean up */
@@ -338,17 +341,14 @@
 	close(2);
 	setsid();
 
-	if (device_open(terminal, O_RDWR) < 0) {
+	if ((fd=device_open(terminal, O_RDWR)) < 0) {
 	    message(LOG|CONSOLE, "Bummer, can't open %s\r\n", terminal);
 	    exit(1);
 	}
-	dup(0);
-	dup(0);
-	/* Grab control of the terminal.  */
-	if (tcsetpgrp (0, getpgrp()) < 0) {
-	    message(LOG|CONSOLE, "tcsetpgrp error: %s\r\n", strerror(errno));
-	}
-	set_term(0);
+	dup(fd);
+	dup(fd);
+	set_term(fd);
+	tcsetpgrp (fd, getpgrp());
 
 	/* Reset signal handlers set for parent process */
 	signal(SIGUSR1, SIG_DFL);
@@ -497,7 +497,7 @@
 
 #endif
 
-void new_initAction (const struct initActionType *a, 
+void new_initAction (initActionEnum action,
 	char* process, char* cons)
 {
     initAction* newAction;
@@ -517,7 +517,7 @@
     newAction->nextPtr = initActionList;
     initActionList = newAction;
     strncpy( newAction->process, process, 255);
-    newAction->action = a->action;
+    newAction->action = action;
     if (*cons != '\0') {
 	strncpy(newAction->console, cons, 255);
     } else
@@ -561,12 +561,12 @@
 	/* No inittab file -- set up some default behavior */
 #endif
 	/* Askfirst shell on tty1 */
-	new_initAction( &(actions[3]), SHELL, console );
+	new_initAction( ASKFIRST, SHELL, console );
 	/* Askfirst shell on tty2 */
 	if (second_console != NULL) 
-	    new_initAction( &(actions[3]), SHELL, second_console );
+	    new_initAction( ASKFIRST, SHELL, second_console );
 	/* sysinit */
-	new_initAction( &(actions[0]), INIT_SCRIPT, console );
+	new_initAction( SYSINIT, INIT_SCRIPT, console );
 
 	return;
 #ifdef BB_FEATURE_USE_INITTAB
@@ -584,7 +584,6 @@
 
 	/* Keep a copy around for posterity's sake (and error msgs) */
 	strcpy(lineAsRead, buf);
-message(LOG|CONSOLE, "read='%s'\n", lineAsRead);
 
 	/* Grab the ID field */
 	s=p;
@@ -628,7 +627,7 @@
 		    }
 		    s = tmpConsole;
 		}
-		new_initAction( a, q, s);
+		new_initAction( a->action, q, s);
 		foundIt=TRUE;
 	    }
 	    a++;
@@ -712,9 +711,9 @@
     {
 	/* Ask first then start a shell on tty2 */
 	if (second_console != NULL) 
-	    new_initAction( &(actions[3]), SHELL, second_console);
+	    new_initAction( ASKFIRST, SHELL, second_console);
 	/* Ask first then start a shell on tty1 */
-	new_initAction( &(actions[3]), SHELL, console);
+	new_initAction( ASKFIRST, SHELL, console);
     } else {
 	/* Not in single user mode -- see what inittab says */
 
@@ -731,7 +730,7 @@
     /* First run the sysinit command */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == SYSINIT) {
-	    waitfor(a->process, console, FALSE);
+	    waitfor(a->process, a->console, FALSE);
 	    /* Now remove the "sysinit" entry from the list */
 	    delete_initAction( a);
 	}
@@ -739,7 +738,7 @@
     /* Next run anything that wants to block */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == WAIT) {
-	    waitfor(a->process, console, FALSE);
+	    waitfor(a->process, a->console, FALSE);
 	    /* Now remove the "wait" entry from the list */
 	    delete_initAction( a);
 	}
@@ -747,7 +746,7 @@
     /* Next run anything to be run only once */
     for( a=initActionList ; a; a=a->nextPtr) {
 	if (a->action == ONCE) {
-	    run(a->process, console, FALSE);
+	    run(a->process, a->console, FALSE);
 	    /* Now remove the "once" entry from the list */
 	    delete_initAction( a);
 	}
@@ -760,7 +759,6 @@
 
     /* Now run the looping stuff for the rest of forever */
     while (1) {
-	message(LOG|CONSOLE, "Looping\n");
 	for( a=initActionList ; a; a=a->nextPtr) {
 	    /* Only run stuff with pid==0.  If they have
 	     * a pid, that means they are still running */
@@ -768,11 +766,11 @@
 		switch(a->action) {
 		    case RESPAWN:
 			/* run the respawn stuff */
-			a->pid = run(a->process, console, FALSE);
+			a->pid = run(a->process, a->console, FALSE);
 			break;
 		    case ASKFIRST:
 			/* run the askfirst stuff */
-			a->pid = run(a->process, console, TRUE);
+			a->pid = run(a->process, a->console, TRUE);
 			break;
 		    /* silence the compiler's incessant whining */
 		    default:
diff --git a/reg_test.sh b/reg_test.sh
index 0a30ae3..2a73fc5 100755
--- a/reg_test.sh
+++ b/reg_test.sh
@@ -6,26 +6,22 @@
 ./busybox cp tar.c testdir
 
 if ! eval diff -u tar.c testdir ; then
-    echo " "
     echo "Bummer.  File copy failed."
     exit 0
 else
     echo "Cool.  File copy is ok."
 fi
-echo " "
 
 rm -rf testdir
 mkdir -p testdir/foo
 ./busybox cp tar.c testdir/foo
 
 if ! eval diff -u tar.c testdir/foo/tar.c ; then
-    echo " "
     echo "Bummer.  File copy to a directory failed."
     exit 0
 else
     echo "Cool.  File copy to a directory is ok."
 fi
-echo " "
 
 
 rm -rf testdir
@@ -33,13 +29,11 @@
 ./busybox cp tar.c testdir/foo/
 
 if ! eval diff -u tar.c testdir/foo/tar.c ; then
-    echo " "
     echo "Bummer.  File copy to a directory w/ a '/' failed."
     exit 0
 else
     echo "Cool.  File copy to a directory w/ a '/' is ok."
 fi
-echo " "
 
 
 rm -rf testdir X11
@@ -47,63 +41,53 @@
 ./busybox cp -a X11 testdir
 
 if ! eval diff -ur X11 testdir ; then
-    echo " "
     echo "Bummer.  Local dir copy failed."
     exit 0
 else
     echo "Cool.  Local dir copy is ok."
 fi
-echo " "
 
 rm -rf testdir X11
 cp -a /etc/X11 .
 ./busybox cp -a X11 testdir/
 
 if ! eval diff -ur X11 testdir ; then
-    echo " "
     echo "Bummer.  Local dir copy w/ a '/' failed."
     exit 0
 else
     echo "Cool.  Local dir copy w/ a '/' is ok."
 fi
-echo " "
 
 rm -rf testdir X11
 cp -a /etc/X11 .
 ./busybox cp -a X11/ testdir
 
 if ! eval diff -ur X11 testdir ; then
-    echo " "
     echo "Bummer.  Local dir copy w/ a src '/' failed."
     exit 0
 else
     echo "Cool.  Local dir copy w/ a src '/' is ok."
 fi
-echo " "
 
 rm -rf testdir X11
 cp -a /etc/X11 .
 ./busybox cp -a X11/ testdir/
 
 if ! eval diff -ur X11 testdir ; then
-    echo " "
     echo "Bummer.  Local dir copy w/ 2x '/'s failed."
     exit 0
 else
     echo "Cool.  Local dir copy w/ 2x '/'s is ok."
 fi
-echo " "
 
 rm -rf testdir X11
 ./busybox cp -a /etc/X11 testdir
 if ! eval diff -ur /etc/X11 testdir ; then
-    echo " "
     echo "Bummer.  Remote dir copy failed."
     exit 0
 else
     echo "Cool.  Remote dir copy is ok."
 fi
-echo " "
 
 
 rm -rf testdir X11
@@ -111,13 +95,11 @@
 
 ./busybox cp -a /etc/X11 testdir/foo
 if ! eval diff -ur /etc/X11 testdir/foo ; then
-    echo " "
     echo "Bummer.  Remote dir copy to a directory failed."
     exit 0
 else
     echo "Cool.  Remote dir copy to a directory is ok."
 fi
-echo " "
 
 
 rm -rf testdir X11
@@ -125,7 +107,6 @@
 
 ./busybox cp -a /etc/X11 testdir/foo/
 if ! eval diff -ur /etc/X11 testdir/foo ; then
-    echo " "
     echo "Bummer.  Remote dir copy to a directory w/ a '/' failed."
     exit 0
 else
@@ -134,3 +115,24 @@
 
 rm -rf testdir
 
+
+rm -rf foo bar
+mkdir foo
+mkdir bar
+
+if ! eval ./busybox cp README foo ; then
+    echo "Bummer.  cp README foo failed."
+    exit 0
+else
+    echo "Cool.  cp README foo is ok."
+fi
+
+if ! eval ./busybox cp foo/README bar ; then
+    echo "Bummer.  cp foo/README bar failed."
+    exit 0
+else
+    echo "Cool.  cp foo/README bar is ok."
+fi
+
+rm -rf foo bar
+